VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsCDKey"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Public Sub DecodeCDKey(ByVal sCDKey As String, ByRef dProductId As Double, ByRef dValue1 As Double, ByRef dValue2 As Double)
On Error Resume Next
    sCDKey = Replace(sCDKey, "-", "")
    sCDKey = Replace(sCDKey, " ", "")
    sCDKey = Funcs.KillNull(sCDKey)
    
    If Len(sCDKey) = 13 Then
        sCDKey = DecodeStarcraftKey(sCDKey)
    ElseIf Len(sCDKey) = 16 Then
        sCDKey = DecodeD2Key(sCDKey)
    Else
        Exit Sub
    End If
    
    dProductId = Val("&H" & Left$(sCDKey, 2))
    
    If Len(sCDKey) = 13 Then
        dValue1 = Val(Mid$(sCDKey, 3, 7))
        dValue2 = Val(Mid$(sCDKey, 10, 3))

    ElseIf Len(sCDKey) = 16 Then
        dValue1 = Val("&H" & Mid$(sCDKey, 3, 6))
        dValue2 = Val("&H" & Mid$(sCDKey, 9))
    End If
    
End Sub

Public Function DecodeD2Key(ByVal key As String) As String
    Dim R As Double, n As Double, n2 As Double, v As Double, _
    v2 As Double, keyvalue As Double, c1 As Byte, c2 As Byte, _
    C As Byte, bValid As Boolean, i As Integer, aryKey(0 To 15) As String, _
    codevalues As String
    
    codevalues = "246789BCDEFGHJKMNPRTVWXZ"
    R = 1
    keyvalue = 0
    
    For i = 1 To 16
    
        aryKey(i - 1) = Mid$(key, i, 1)
        
    Next i
    
    For i = 0 To 15 Step 2
        c1 = InStr(1, codevalues, aryKey(i)) - 1
        If c1 = -1 Then c1 = &HFF
        n = c1 * 3
        c2 = InStr(1, codevalues, aryKey(i + 1)) - 1
        If c2 = -1 Then c2 = &HFF
        n = c2 + n * 8
        
        If n >= &H100 Then
        
            n = n - &H100
            keyvalue = keyvalue Or R
            
        End If
        
        n2 = n
        n2 = RShift(n2, 4)
        aryKey(i) = GetHexValue(n2)
        aryKey(i + 1) = GetHexValue(n)
        R = LShift(R, 1)
        
Cont:

    Next i
    
    v = 3
    
    For i = 0 To 15
    
        C = GetNumValue(aryKey(i))
        n = Val(C)
        n2 = v * 2
        n = n Xor n2
        v = v + n
        
    Next i
    
    v = v And &HFF
    
    For i = 15 To 0 Step -1
    
        C = Asc(aryKey(i))
        
        If i > 8 Then
        
            n = i - 9
            
        Else
        
            n = &HF - (8 - i)
            
        End If
        
        n = n And &HF
        c2 = Asc(aryKey(n))
        aryKey(i) = Chr$(c2)
        aryKey(n) = Chr$(C)
        
    Next i
    
    v2 = &H13AC9741
    
    For i = 15 To 0 Step -1
    
        C = Asc(UCase(aryKey(i)))
        aryKey(i) = Chr$(C)
        
        If Val(C) <= Asc("7") Then
        
            v = v2
            c2 = v And &HF
            c2 = c2 And 7
            c2 = c2 Xor C
            v = RShift(v, 3)
            aryKey(i) = Chr$(c2)
            v2 = v
            
        ElseIf Val(C) < Asc("A") Then
            c2 = CByte(i)
            c2 = c2 And 1
            c2 = c2 Xor C
            aryKey(i) = Chr$(c2)
        End If
    Next i
    DecodeD2Key = Join(aryKey, "")
    Erase aryKey()
End Function

Public Function DecodeStarcraftKey(ByVal sKey As String) As String
On Error Resume Next
    Dim R As Double, n As Double, n2 As Double, v As Double, _
    v2 As Double, keyvalue As Double, c1 As Byte, c2 As Byte, C As Byte, _
    bValid As Boolean, i As Integer, aryKey(0 To 12) As String
    
    For i = 1 To 13
    
        aryKey(i - 1) = Mid$(sKey, i, 1)
        
    Next i
    
    v = 3
    
    For i = 0 To 11
    
        C = aryKey(i)
        n = Val(C)
        n2 = v * 2
        n = n Xor n2
        v = v + n
        
    Next i
    
    v = v Mod 10
    
    If Hex(v) = aryKey(12) Then
    
        bValid = True
        
    End If
    
    v = 194
    
    For i = 11 To 0 Step -1
    
        If v < 7 Then GoTo continue
        C = aryKey(i)
        n = CInt(v / 12)
        n2 = v Mod 12
        v = v - 17
        c2 = aryKey(n2)
        aryKey(i) = c2
        aryKey(n2) = C
        
    Next i
    
continue:

    v2 = &H13AC9741
    
    For i = 11 To 0 Step -1
    
        C = UCase$(aryKey(i))
        aryKey(i) = C
        
        If Asc(C) <= Asc("7") Then
        
            v = v2
            c2 = v And &HFF
            c2 = c2 And 7
            c2 = c2 Xor C
            v = RShift(CLng(v), 3)
            aryKey(i) = c2
            v2 = v
            
        ElseIf Asc(C) < 65 Then
        
            c2 = CByte(i)
            c2 = c2 And 1
            c2 = c2 Xor C
            aryKey(i) = c2
        End If
    Next i
    DecodeStarcraftKey = Join(aryKey, "")
    Erase aryKey()
End Function

Public Function GetHexValue(ByVal v As Long) As String

    v = v And &HF
    If v < 10 Then
        GetHexValue = Chr$(v + &H30)
    Else
        GetHexValue = Chr$(v + &H37)
    End If
    
End Function
Public Function GetNumValue(ByVal C As String) As Long
On Error Resume Next
    C = UCase(C)
    If IsNumeric(C) Then
        GetNumValue = Asc(C) - &H30
    Else
        GetNumValue = Asc(C) - &H37
    End If
End Function
Public Function LShift(ByVal pnValue As Long, ByVal pnShift As Long) As Double
On Error Resume Next
LShift = CDbl(pnValue * (2 ^ pnShift))
End Function


Public Function RShift(ByVal pnValue As Long, ByVal pnShift As Long) As Double
On Error Resume Next
RShift = CDbl(pnValue \ (2 ^ pnShift))
End Function
